#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_TurretWingCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_TurretWingCFG> Fish_TurretWingCFG::msSingleton(nullptr);

int Fish_TurretWingCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_TurretWingCFGData* Fish_TurretWingCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_TurretWingCFGData>& Fish_TurretWingCFG::GetMapData()
{
	return mMapData;
}

void Fish_TurretWingCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_TurretWingCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_TurretWingCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		{
			const char* EffectType = element->Attribute("EffectType");
			std::vector<std::string> vecEffectType;
			boost::split(vecEffectType, EffectType, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecEffectType.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecEffectType[i].c_str(), &temp))
				{
					data.mEffectType.push_back(temp);
				}
			}
		}
		data.mWingRES = element->Attribute("WingRES");
		{
			const char* ItemID = element->Attribute("ItemID");
			std::vector<std::string> vecItemID;
			boost::split(vecItemID, ItemID, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecItemID.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecItemID[i].c_str(), &temp))
				{
					data.mItemID.push_back(temp);
				}
			}
		}
		data.mRoute = element->IntAttribute("Route");
		data.mTopLevel = element->IntAttribute("TopLevel");
		data.mLvUpItem = element->IntAttribute("LvUpItem");
		data.mLvUpCount = element->IntAttribute("LvUpCount");
		data.mRandItem = element->IntAttribute("RandItem");
		data.mRandItemCount = element->IntAttribute("RandItemCount");
		{
			const char* ResetReturnCount = element->Attribute("ResetReturnCount");
			std::vector<std::string> vecResetReturnCount;
			boost::split(vecResetReturnCount, ResetReturnCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecResetReturnCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecResetReturnCount[i].c_str(), &temp))
				{
					data.mResetReturnCount.push_back(temp);
				}
			}
		}
		data.mResetValue = element->IntAttribute("ResetValue");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_TurretWingCFG::Load()
{
	Load("../Config/Fish_TurretWingCFG.xml");
}

Fish_TurretWingCFG* Fish_TurretWingCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_TurretWingCFG());
	}
	return msSingleton.get();
}
